Summary: 	Load balance and fail over utility for TCP based services
Name: 		crossroads
Version: 	2.67
Release: 	1.8
License: 	GPLv3
Group: 		Applications/Utilities
URL: 		http://crossroads.e-tunity.com/

Source: 	http://crossroads.e-tunity.com/downloads/versions/crossroads-devel.tar.gz
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: 	perl yodl gcc-c++
Requires: 	perl

%description
Crossroads is an open source load balance and fail over utility for TCP based 
services. It is a daemon running in user space, and features extensive 
configurability, polling of back ends using 'wakeup calls', detailed status 
reporting, 'hooks' for special actions when backend calls fail, and much more. 
Crossroads is service-independent: it is usable for HTTP(S), SSH, SMTP, DNS, 
etc.. In the case of HTTP balancing, Crossroads can provide 'session 
stickiness' for back end processes that need sessions, but aren't session-aware 
of other back ends.

%prep
%setup -n %{name}-%{version}

%build
%{__make} %{?_smp_mflags} PREFIX=%{_prefix} local
#needs yo2man
#{__make} %{?_smp_mflags} PREFIX=%{_prefix} documentation

%install
%{__rm} -rf %{buildroot}
%{__install} -d %{buildroot}%{_sbindir} %{buildroot}%{_bindir}
%{__make} install DESTDIR="%{buildroot}"

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc ChangeLog
%doc doc/xr.pdf doc/xr.odt
%{_sbindir}/xrctl
%{_sbindir}/xr
%{_mandir}/man1/xr*
%{_mandir}/man5/xrctl*

%changelog
* Thu Jul 29 2010 Carsten Schoene <cs@linux-administrator.com> - 2.67-1
2.67 [KK 2010-06-11]
- Further bugfix in xrctl to shell-escape all XR parameters where
  necessary (including e.g. url matching regexps etc.).

2.66 [KK 2010-06-09]
- Bugfix in xrctl, --host-match arguments are now shell-quoted (they
  are regular expressions and can contain pipe characters etc). Thanks
  Chewped for reporting.

2.65 [KK 2010-04-26]
- Bugfix in backend/connect.cc - if the determination whether a back
  end is available goes haywire, the client socket may stay open and
  not be consumed. Thanks Franz J. for reporting!
- Version stamped as STABLE.

2.64 [KK 2010-01-29]
- Fixed signal handling for start/stop/restart.
- Web interface now immediately shuts down at a stop request, so that
  next xr instances can grab the web interface port immediately.

* Thu Jan 21 2010 Carsten Schoene <cs@linux-administrator.com> - 2.63-1
2.63 [KK 2010-01-11]
- Previous 2.62 stamped as stable, 2.63 will be the new development
  trunk.
  
2.62 [KK 2010-01-08]
- Fixed possible coredump cause in Balancer::serve(), which might
  explain some troubles during high load (many really concurrent requests).

2.61 [KK 2009-11-17]
- Netbuffer::netwrite() will abort after 5 attempts that yield 0
  written bytes. Probable cause of CPU hogging - thx Franz J. for
  reporting.
- Fixed potential cause of crashes in base class for Dispatcher
  (algorithm handler would not get initialized in the constructors).

2.60 [KK 2009-11-02]
- Some errors demoted to informational messages to choke the amount of
  log information that's generated.

2.59 [KK 2009-10-14]
- Bugfix in logger handling of xrctl, read
  http://xrforum.org/viewtopic.php?t=495 if you fancy. Thanks Hobbit
  for reporting this!
  
2.58 [KK 2009-10-14] 
- Added test/ftp.xml as a sample ftp service configuration.
- Implemented URL-based dispatching: flag --url-match/-j, present in
  xrctl, tested in test/urlmatch.xml, added to web interface
- Usage information now shows long versions of flags first.

2.57 [KK 2009-09-14]
- Output of "xrctl status" colorized when a service is not running,
  thanks Frederik D. for the suggestion and the code!
- Small cleanup of xrctl's usage information.  

2.56 [KK 2009-05-26]
- Bugfix in cleaning of IPStore map
- Implemented flag --remove-reservations (xrctl: tag: removereservations)
- Timeouts adjusted: all read time outs set to 30, client-write set to
  5, backend-write set to 3
- Implemented tag prefixtimestamp in system block to force timestamping.  

* Wed May 13 2009 Carsten Schoene <cs@linux-administrator.com> - 2.55-1
- new release 2.55
 - This version fixes a number of bugs, features a rewrite of the
  "stored-ip" dispatcher, introduces counting of back end errors
  for diagnostic purposes, and features updated documentation.

- changes of 2.44 release
 - This version introduces the ability to rewrite Host: headers
   in HTTP mode with the hostname of a back end to which Crossroads
   is dispatching.
 - The Activity overview of the Web... interface now shows the number
   of used file descriptors and the maximum limit.
 - A number of bugs were fixed and code parts were slightly reworked

* Wed Jan 06 2009 Carsten Schoene <cs@linux-administrator.com> - 2.41-1
- new release 2.41
 - This version fixes some smaller bugs or omissions, and further improves the management Web interface

* Wed Nov 12 2008 Carsten Schoene <cs@linux-administrator.com> - 2.36-1
- new release 2.36
 - The balancer control script xrctl was rewritten
   to use an XML configuration file describing all services.
 - The management Web interface is much richer,
   allowing modification of more properties of the balancer
   and allowing addition or deletion of back ends.
 - DOS protection was extended to delay or block
   client IP addresses that exceed a connection threshold.
 - Resolved back end host names are cached to ease the load on DNS.
 - Back end verification supports HTTP GET or TCP connects
   to ports other than the back end itself.
 - Portability issues for gcc 3.4, Solaris, and 64-bit systems were solved.

* Wed Oct 08 2008 Carsten Schoene <cs@linux-administrator.com> - 2.18-1
- new upstream version 2.18, this is the new stable release
* Sat Aug 16 2008 Carsten Schoene <cs@linux-administrator.com> - 2.05-1
- new upstream version 2.05
* Fri Aug 08 2008 Carsten Schoene <cs@linux-administrator.com> - 2.00-1
- new upstream version 2.00
* Mon May 19 2008 Carsten Schoene <cs@linux-administrator.com> - 1.80-1
- new upstream version 1.80
* Mon Apr 21 2008 Carsten Schoene <cs@linux-administrator.com> - 1.79-1
- new upstream version 1.79
* Fri Mar 07 2008 Carsten Schoene <cs@linux-administrator.com> - 1.77-1
- Initial package.

